$(document).ready(function() {
	var _wrapper = $('#carousel_wrapper');										// wrapper div for reference
	var _container = $('#carousel_container');									// container div for reference
	var _next = $('#carousel_next');											// next button for refernece
	var _prev = $('#carousel_prev');											// prev button for reference
	var _items = $('#carousel_container div');									// items in container for reference
	var _item_width = parseInt(_items.eq(0).css('width'));						// width of each item
	var _total_width = _item_width * _items.length;								// width of all items
	var _left = parseInt(_container.css('left'));								// the left position of the container
	var _items_per_frame = 4;													// the amount of item's to move between per movement
	var _increment = _item_width * _items_per_frame;							// the increment amount (calculated by multiplying the single item width by the number of items per frame)
	var _max_left = (_total_width - (_item_width * _items_per_frame)) * -1;		// the left position that the container div cannot exceed. used to mark the end of the carousel
	var _speed = 1000;															// the speed of transition when the user click the prev or next buttons (milliseconds)
	var _buffer = 50;															// the buffer amount in pixels (the amount to 'bounce' by)
	var _buffer_speed = 350;													// the speed of the transition between the end of the buffer and back to the new left position
	
	// hide the prev button as we are at point 0 and can't go back
	_prev.find('img').hide();
	
	// set the width of the container div to the sum of the widths of all the elements
	_container.css('width', _total_width + 'px');
	
	// next button click handler
	_next.click(function() {
		// calculate the left position after animation by deducting the increment amount from the current left position
		var new_left = (parseInt(_left) - parseInt(_increment));
		// check that the new left position is greater than or equal to the maximum left position
		// it is 'greater than or equal to' because, as we are going LEFT, beyond the original '0' starting point, we are dealing with negative numbers
		if(new_left >= _max_left) {
			// check to see if the container element is currently in animation. If it is, don't continue
			// Prevents people clicking many times and confusing it
			if($(_container + ':animated').size() == 0) {
				// work out the new buffer position by deducting the _buffer constatn from the new left position
				var buffer = new_left - _buffer;
				// animate to the buffer position
				_container.animate({left: buffer + 'px'}, _speed, function() {
					// animate back to the new left position
					_container.animate({left: new_left + 'px'}, _buffer_speed, function() {
						// if the current left position is equal to the max left position, hide the next button
						// and show the prev button as there is nowhere to go to from here
						if(_left == _max_left) {
							_next.find('img').fadeOut();
						}
						
						if(_left != 0){
							_prev.find('img').fadeIn();
						}
					});
				});
				// store the new left position
				_left = parseInt(new_left);
			};
		};
		// return
		return false;
	});
	
	// prev button click handler
	_prev.click(function() {
		// calculate the left position after animation by adding the increment amount to the current left position
		var new_left = (parseInt(_left) + parseInt(_increment));
		// check that the new left position is less than or equal to the maximum left position
		// it is 'less than or equal to' because, as we are going RIGHT, beyond the original '0' starting point, we are dealing with positive numbers
		if(new_left <= 0) {
			// check to see if the container element is currently in animation. If it is, don't continue
			// Prevents people clicking many times and confusing it
			if($(_container + ':animated').size() == 0) {
				// work out the new buffer position by adding the _buffer constatn from the new left position
				var buffer = new_left + _buffer;
				// animate to the buffer position
				_container.animate({left: buffer + 'px'}, _speed, function() {
					// animate back to the new left position
					_container.animate({left: new_left + 'px'}, _buffer_speed, function() {
						// if the current left position is equal tp 0, hide the prev button
						// and show the next button as there is nowhere to go to from here
						if(_left == 0) {
							_prev.find('img').fadeOut();
							_next.find('img').fadeIn();
						};
						
						if(_left != _max_left){
							_next.find('img').fadeIn();
						}
						
					});
				});
				// store the new left position
				_left = parseInt(new_left);
			};
		};
		// return
		return false;
	});
	
});